// Filename           : CLICTD_dataout_comparator.sv
// Author             : Núria Egidos 
// Created on         : 20/6/18
// Last modification  : 21/1/19
// Project            : Doctoral student, verification of CLICTD
// Description        : Comparator

`ifndef __CLICTD_dataout_comparator_sv__
`define __CLICTD_dataout_comparator_sv__

//import uvm_pkg::*;
//`include <uvm_macros.svh>

// This comparator assumes in-order arrival of transactions, i.e. the order of 
// arrival of a transaction from the predictor/golden model matches the order of 
// arrival of a transaction generated by the monitor probing the outputs


// This structure will enable having more than one export in the same scoreboard; 
// when the respective anlaysis ports call write(), the factory will automatically invoke 
// write_ideal() for the export associated to the port probing the expected outputs from the
// golden model, or write_actual() for the export associated to the port probing the actual
// outputs, depending on which of the ports is calling
//`uvm_analysis_imp_decl(_ideal)
//`uvm_analysis_imp_decl(_actual)


// ANYTHING RELATED TO COVERGROUP HERE SHOULD BE PLACED IN A SUBSCRIBER. FOR A QUICK TEST, IT'S BEEN PLACED HERE
// http://cluelogic.com/2011/07/uvm-tutorial-for-candy-lovers-environment/



class CLICTD_dataout_comparator extends CLICTD_comparator;
	`uvm_component_utils(CLICTD_dataout_comparator) // Register the component to the factory
	
	
	
	bit [4:0] aux_var_to_store_tot;
	bit [12:0] aux_var_to_store_toa;
	
	
	covergroup covergroup_fields_time_meas;
					           cover_tot_ns: coverpoint aux_var_to_store_tot{
																                         bins very_low = {[0:1]};
																																									bins intermediate = {[2:16]};
																																									bins high = default; // the rest of values
																              }
																cover_toa_ns: coverpoint aux_var_to_store_toa{
																                         bins very_low = {[0:1]};
																																									bins intermediate = {[2:255]}; // until the max value achievable with 8 bits, which is the max ToA in nominal acquisition mode
																																									bins high = default; // the rest of values
																              }
																/*
																cover_divergence_results_toa: coverpoint aux_divergence_results_toa { // toa result more than 2 counts apart from nominal value in this column
																                                          bins column0 = 0;
																																																										bins column1 = 1;
																																																										bins column2 = 2;
																																																										bins column3 = 3;
																																																										bins column4 = 4;
																																																										bins column5 = 5;
																																																										bins column6 = 6;
																																																										bins column7 = 7;
																																																										bins column8 = 8;
																																																										bins column9 = 9;
																																																										bins column10 = 10;
																																																										bins column11 = 11;
																																																										bins column12 = 12;
																																																										bins column13 = 13;
																																																										bins column14 = 14;
																																																										bins column15 = 15;
																                              }
																																														// (the same for tot)
															*/
															
					endgroup: covergroup_fields_time_meas

	// Declaration of the export used to connect to the analysis port in the agent
  // (to probe the outputs or internal signals of the DUT)
  uvm_analysis_export #(CLICTD_dataout_transaction) analysis_export_actual;
  // Declaration of the export used to connect to the analysis port in the golden 
  // model (to probe the expected outputs)
  uvm_analysis_export #(CLICTD_dataout_transaction) analysis_export_ideal;


  // Declaration of the fifos used to collect the streams of transactions
  // coming from the analysis ports, so as to synchronise them to 
  // be able to compare them:
  // For the transactions coming from the golden model (to probe ideal outputs)
  uvm_tlm_analysis_fifo #(CLICTD_dataout_transaction) ideal_fifo;
  // For the transactions coming from the agent (to probe actual outputs)
  uvm_tlm_analysis_fifo #(CLICTD_dataout_transaction) actual_fifo;


  BitsMonitorSlowcontrolReg bits_slowcontrol_reg_obj;
		FieldsTimeMeasurements time_measurements_obj;
		FieldsTimeMeasurements_for_coverage time_measurements_obj_for_coverage;
		FieldsConfigureMatrix_for_coverage config_matrix_obj_for_coverage;
		ReportingEnable reporting_enable_obj;
  
		string testame;

  logic [`ROWS*`NUMBER_BITS_READOUT_PER_SUPERPIXEL_COMPRESSION_DISABLED-1:0] aux_vector_actual, aux_vector_ideal;
		
		//covergroup_fields_time_meas covgroup_fields_time_meas;

  
	// - - - - - - - - - - - - Constructor
	function new(string name, uvm_component parent);
		super.new(name, parent);
		//covgroup_fields_time_meas = new();
		covergroup_fields_time_meas = new;
	endfunction: new


  // - - - - - - - - - - - - Build phase: build the hierarchy
	function void build_phase(uvm_phase phase);
		   super.build_phase(phase);
					
					
					if( !uvm_config_db#(string)::get(this, "", "testname", testname) )
         `uvm_error( `NOTESTNAME, $sformatf("testname not found in database for %s", this.get_full_name()) )
									
									
		   if( !uvm_config_db#(BitsMonitorSlowcontrolReg)::get(this, "", "bits_slowcontrol_reg_obj", bits_slowcontrol_reg_obj) )
         `uvm_error( `NOBITSSLOWCONTROLREG, $sformatf("bits_slowcontrol_reg_obj not found in database for %s", this.get_full_name()) )
									
					if( !uvm_config_db#(FieldsTimeMeasurements)::get(this, "", "time_measurements_obj", time_measurements_obj) )
         `uvm_error( `NOTIMEMEASUREMENTS, $sformatf("time_measurements_obj not found in database for %s", this.get_full_name()) )
									
					if (testname == `READOUT_TEST_FOR_COVERAGE) begin
					    if( !uvm_config_db#(FieldsTimeMeasurements_for_coverage)::get(this, "", "time_measurements_obj_for_coverage", time_measurements_obj_for_coverage) )
         `uvm_error( `NOTIMEMEASUREMENTS, $sformatf("time_measurements_obj_for_coverage not found in database for %s", this.get_full_name()) )
					end
									
					if( !uvm_config_db#(ReportingEnable)::get(this, "", "reporting_enable_obj", reporting_enable_obj) )
         `uvm_error( `NOREPORTINGENABLE, $sformatf("reporting_enable_obj not found in database for %s", this.get_full_name()) )
									
					if( !uvm_config_db#(FieldsConfigureMatrix_for_coverage)::get(this, "", "config_matrix_obj_for_coverage", config_matrix_obj_for_coverage) )
         `uvm_error( `NOMATRIXCONFIG, $sformatf("config_matrix_obj_for_coverage not found in database for %s", this.get_full_name()) )
									
									
    // Create the exports
		analysis_export_actual = new("analysis_export_actual", this);
		analysis_export_ideal = new("analysis_export_ideal", this);
		// Create the FIFOs
  	actual_fifo = new("actual_fifo", this);
		ideal_fifo = new("ideal_fifo", this);
	endfunction: build_phase


	
  // - - - - - - - - - - - - Connect phase: connect FIFOs and exports
	function void connect_phase(uvm_phase phase);
    super.connect_phase(phase);
    analysis_export_actual.connect(actual_fifo.analysis_export);
		analysis_export_ideal.connect(ideal_fifo.analysis_export);
                                     
	endfunction: connect_phase


  // - - - - - - - - - - - - Run phase: here is where the transactions are retrieved from the 
  // exports, stored temporarily in the FIFOs to synchronise and then
  // retrieved from the FIFOs to compare them
	task run();
    
		  number_transactions_evaluated[STATUS_RESET] = 0;				
		  number_transactions_evaluated[STATUS_SECOND_READOUT_ALL_ZEROS] = 0;
    number_transactions_evaluated[STATUS_THIRD_READOUT_NOTHING_HAPPENS] = 0;
    number_transactions_evaluated[STATUS_FOURTH_READOUT_ALL_ZEROS] = 0;
    number_transactions_evaluated[STATUS_FIFTH_READOUT_NOTHING_HAPPENS] = 0;
		  number_transactions_evaluated[STATUS_CONFIG_READOUT_FIRST_HALF] = 0;
		  number_transactions_evaluated[STATUS_CONFIG_READOUT_SECOND_HALF] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv1] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv2] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv3] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv1] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv2] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv3] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv1] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv2] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv3] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv1] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv2] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv3] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_longtoa_nocompr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_longtoa_compr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_phcount_nocompr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_MATRIX_READOUT_ACQUIRED_shorttot_phcount_compr_totDiv0] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_EXTERNAL_WORKING] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_EXTERNAL_NOTHING_HAPPENS] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_INTERNAL_WORKING] = 0;
				number_transactions_evaluated[STATUS_TESTPULSE_INTERNAL_NOTHING_HAPPENS] = 0;


    // Note: the format in column_content is the following:
    //   COLUMN 15       COLUMN 14     ...   COLUMN 0
    // 0 ......... 21 0 ......... 21   ... 0 ......... 21
   
    fork
        // Obtain transactions from the model and from the monitor and compare them 
				dataoutcomparator_action();
        // Detect timeout when waiting for start readout condition
        timeout_action();
   join_none
   
   // The fork join_none is used to avoid that this forever begin blocks the execution of other 
   // run_phase tasks in the hierarchy
	endtask: run

  

  // - - - - - - - - - - - - Other tasks
  //
  // Compare the incoming transactions. This function is declared virtual so that 
  // if some other comparator is extended from this one, the child comparator can 
  // override this method, and when the method is called, the child version will be executed
	virtual function void compare(input CLICTD_dataout_transaction dataout_transaction_ideal, CLICTD_dataout_transaction dataout_transaction_actual);
           int aux_size_actual, aux_size_ideal;
											int number_discrepancies_for_this_transaction;
											int all_data_equal_whole_column;
											int difference1,difference2;
           field_dataouttrans_array_type fields_with_error;
           bit comparison_result;
											array_exitcode_fullcolumn_type comparison_result_acquired;
											array_exitcode_type aux_comparison_result_acquired;
											array_exitcodeconfig_fullcolumn_type comparison_result_configured;
											array_exitcodeconfig_type aux_comparison_result_configured;
											int coordinates_pulsed[string];
						     string current_coordinate,aux_coordinate, pulsing_this_coordinate;
											
											if (testname == `READOUT_TEST_FOR_COVERAGE) begin
											    coordinates_pulsed.delete();
															foreach (config_matrix_obj_for_coverage.superpixels_to_pulse[i]) begin
																		aux_coordinate = $sformatf("%0d-%0d-%0d",config_matrix_obj_for_coverage.superpixels_to_pulse[i].column,config_matrix_obj_for_coverage.superpixels_to_pulse[i].superpixel_segment,config_matrix_obj_for_coverage.superpixels_to_pulse[i].superpixel_in_segment);
																		coordinates_pulsed[aux_coordinate] = i; // the index is given by the value of column, superpixel_segment and superpixel_in_segment at this position of the superpixels_to_pulse array;
									                                        									// the value stored at this index is the corresponding position in the superpixels_to_pulse array
															end
											end

           comparison_result = dataout_transaction_ideal.compare(dataout_transaction_actual);

           number_transactions_evaluated[chip_status_obj.chip_status] =  number_transactions_evaluated[chip_status_obj.chip_status] + 1;
           if (number_transactions_evaluated[chip_status_obj.chip_status] == 1) number_discrepancies[chip_status_obj.chip_status] = 0; // there will only be discrepancies if some transaction has been evaluated
    
           if      (chip_status_obj.chip_status == STATUS_RESET) begin: status_reset
                    if ( comparison_result ) begin 
                        `uvm_info("compare", $sformatf(":) DATA_OUT has the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW); 
                    end  
                    else if ( dataout_transaction_ideal.fields_with_error.exists(DATAOUT) ) begin
                       `uvm_info("compare", $sformatf(":( DATA_OUT does NOT have the expected value for chip_status: %s", chip_status_obj.chip_status), UVM_LOW);
                        increment_number_discrepancies(); 
                    end
										   
                   																																							         
           end: status_reset
											
											
											else if (chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv0 || 
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv1 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv2 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_nocompr_totDiv3 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv1 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv2 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_nocompr_totDiv3 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv1 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv2 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_nominal_compr_totDiv3 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv1 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv2 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_longtot_nominal_compr_totDiv3 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_longtoa_nocompr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_longtoa_compr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_phcount_nocompr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_MATRIX_READOUT_ACQUIRED_shorttot_phcount_compr_totDiv0 ||
																				chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_EXTERNAL_NOTHING_HAPPENS ||
																				chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_WORKING || chip_status_obj.chip_status == STATUS_TESTPULSE_INTERNAL_NOTHING_HAPPENS )  begin: status_readout_acquired
											
											
											         if (testname == `READOUT_TEST_FOR_COVERAGE) begin
																				    comparison_result_acquired = compare_two_columndata_broken_into_superpixeldata_for_coverage ( .bits_slowcontrol_reg_obj(bits_slowcontrol_reg_obj), .superpixel_data_measured(dataout_transaction_actual.column_content_breakdown),
																                                .superpixel_data_expected(dataout_transaction_ideal.column_content_breakdown),	.time_measurements_obj_for_coverage(time_measurements_obj_for_coverage) );
																				end
																				else begin
											              comparison_result_acquired = compare_two_columndata_broken_into_superpixeldata ( .bits_slowcontrol_reg_obj(bits_slowcontrol_reg_obj), .superpixel_data_measured(dataout_transaction_actual.column_content_breakdown),
																				                             .superpixel_data_expected(dataout_transaction_ideal.column_content_breakdown) );
																				end
																																																	
																																																	
																				
																																																	
																				all_data_equal_whole_column = 0;																												
																				for (int ss = 0; ss < `SUPERPIXEL_SEGMENTS; ss++) begin
																				     for (int sis = 0; sis < `SUPERPIXELS_IN_ONE_SEGMENT; sis++) begin																		
										                   aux_comparison_result_acquired.delete(); aux_comparison_result_acquired = comparison_result_acquired[ss][sis];
																													current_coordinate = $sformatf("%0d-%0d-%0d",dataout_transaction_actual.column_counter,ss,sis);
																													if (coordinates_pulsed.exists(current_coordinate)) begin
																													    // Is a digital pulse applied to this coordinate?
																																	if (config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].pulsed_digital_or_forcedisc == `SUPERPIXEL_COORDINATE_EXPECTS_DIGITAL_TEST_PULSE)
																																	    pulsing_this_coordinate = $sformatf("DIGITAL TEST PULSE APPLIED IN THIS COORDINATE, AND DISC PULSES IN BITS %0d AND %0d",config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].bit_applydiscpulse_0, 
																																					config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].bit_applydiscpulse_1);
																													    // Is some pulse forced to some dicriminator bits in this coordinate?
																																	else if (config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].pulsed_digital_or_forcedisc == `SUPERPIXEL_COORDINATE_EXPECTS_FORCE_PUSE_AT_SOME_DISC_BIT)
																																	    pulsing_this_coordinate = $sformatf("DISCRIMINATOR PULSE APPLIED IN THIS COORDINATE IN BITS %0d AND %0d",config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].bit_applydiscpulse_0, 
																																					config_matrix_obj_for_coverage.superpixels_to_pulse[coordinates_pulsed[current_coordinate]].bit_applydiscpulse_1);
																													end
																													// This coordinate is not pulsed
																													else pulsing_this_coordinate = "NO PULSE APPLIED TO THIS COORDINATE";
																													
																													
																
																													
																		           foreach (aux_comparison_result_acquired[j]) begin
																													        // -------------------------------------------------------------------------
																													        if (testname == `READOUT_TEST_FOR_COVERAGE) begin: readout_test_for_coverage
																																					            if (aux_comparison_result_acquired[j] != ALL_DATA_EQUAL) begin: there_is_error_for_coverage
																																					
																																																								//if (reporting_enable_obj.enable_reporting_dataoutcomparator_readoutacquired == `YES) begin

																																					     																							// Nominal acquisition mode
																																																																	if      ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b0 ) begin
																																														          																			difference1 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot;
																																																																											difference2 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b, MEASURED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b, DIFFERENCE TOT = %0d, DIFFERENCE TOA = %0d (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference1,difference2,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																											
																																																																											//////////////////////////////////// COVERAGE COLLECTION //////////////////////////////////
																																																																											aux_var_to_store_tot = dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot;
																													                                              aux_var_to_store_toa = dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa;
																																																																											//covgroup_fields_time_meas.sample();
																																																																											covergroup_fields_time_meas.sample();
																																																																											//////////////////////////////////////////////////////////////////////////////////////////
																													
																																																																	end
																																																																	// Long ToA acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			difference2 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].longtoa;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, long toa = %0d, hitflag = %b, MEASURED: hitmap = %h, long toa = %0d, hitflag = %b, DIFFERENCE TOA = %0d (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].longtoa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference2,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																	end
						    																																																							// Photon counting acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b1 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			difference1 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].photoncount;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, photon count = %0d, hitflag = %b, MEASURED: hitmap = %h, photon count = %0d, hitflag = %b, DIFFERENCE PHOTON COUNT = %0d (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].photoncount, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference1,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																	end
																																																								//end
																																																								//else begin
																																																								//    `uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d", 
                                     																			//    aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis ), UVM_LOW);
																																																								//end

                                     																			increment_number_discrepancies();
																																																				end: there_is_error_for_coverage
																																																				else begin: no_error_for_coverage
																																	      																			all_data_equal_whole_column++;
																																	     																			if (reporting_enable_obj.enable_reporting_dataoutcomparator_readoutacquired == `YES) begin
																																	             																			// Nominal acquisition mode
																																																																	if      ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b0 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b, MEASURED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																	end
																																																																	// Long ToA acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, long toa = %0d, hitflag = %b, MEASURED: hitmap = %h, long toa = %0d, hitflag = %b (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].longtoa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																	end
						    																																																							// Photon counting acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b1 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, photon count = %0d, hitflag = %b, MEASURED: hitmap = %h, photon count = %0d, hitflag = %b, (tot ns = %0d, toa ns = %0d, tpEnableDigital[%0d][%0d][%0d] = %b, mask[%0d][%0d][%0d] = %h), %s", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].photoncount, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											time_measurements_obj_for_coverage.tot_ns, time_measurements_obj_for_coverage.toa_ns, 
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.tpEnableDigital[dataout_transaction_actual.column_counter][ss][sis],
																																																																											dataout_transaction_actual.column_counter, ss,sis, config_matrix_obj_for_coverage.mask[dataout_transaction_actual.column_counter][ss][sis],pulsing_this_coordinate), UVM_LOW);
																																																																	end
																																																										end
																																																				end: no_error_for_coverage
																																					end: readout_test_for_coverage
																																					// -------------------------------------------------------------------------
																																					else begin: other_test
																																					            if (aux_comparison_result_acquired[j] != ALL_DATA_EQUAL) begin: there_is_error_other_test
																																					
																																																								//if (reporting_enable_obj.enable_reporting_dataoutcomparator_readoutacquired == `YES) begin

																																					     																							// Nominal acquisition mode
																																																																	if      ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b0 ) begin
																																														          																			difference1 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot;
																																																																											difference2 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b, MEASURED: hitmap = %h, tot = %0d, toa = %0d, hitflag = %b, DIFFERENCE TOT = %0d, DIFFERENCE TOA = %0d (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].tot,
																																																																											dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].toa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference1,difference2,
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
																																																																	// Long ToA acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			difference2 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].longtoa;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, long toa = %0d, hitflag = %b, MEASURED: hitmap = %h, long toa = %0d, hitflag = %b, DIFFERENCE TOA = %0d (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].longtoa, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference2,
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
						    																																																							// Photon counting acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b1 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			difference1 = dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount - dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].photoncount;
																																														         																			`uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: hitmap = %h, photon count = %0d, hitflag = %b, MEASURED: hitmap = %h, photon count = %0d, hitflag = %b, DIFFERENCE PHOTON COUNT = %0d (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_map,
																																																							 																			dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].photoncount, dataout_transaction_actual.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											difference1,
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
																																																								//end
																																																								//else begin
																																																								//    `uvm_info("compare", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d", 
                                     																			//    aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis ), UVM_LOW);
																																																								//end

                                     																			increment_number_discrepancies();
																																																				end: there_is_error_other_test
																																																				else begin: no_error_other_test
																																	      																			all_data_equal_whole_column++;
																																	     																			if (reporting_enable_obj.enable_reporting_dataoutcomparator_readoutacquired == `YES) begin
																																	             																			// Nominal acquisition mode
																																																																	if      ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b0 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, hitmap = %h, tot = %0d, toa = %h, hitflag = %b (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].tot, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].toa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag,
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
																																																																	// Long ToA acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b0 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, hitmap = %h, long toa = %0d, hitflag = %b (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].longtoa,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, 
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
						    																																																							// Photon counting acquisition mode
																																																																	else if ( bits_slowcontrol_reg_obj.photonCnt == 1'b1 && bits_slowcontrol_reg_obj.longCnt == 1'b1 ) begin
																																														         																			`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, hitmap = %h, photon count = %0d, hitflag = %b (tot long ns = %0d, tot short ns = %0d, toa ns = %0d)", 
                                                        																			aux_comparison_result_acquired[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_map, dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].photoncount,
																																																																											dataout_transaction_ideal.column_content_breakdown.superpixel[ss][sis].hit_flag, 
																																																																											time_measurements_obj.tot_long_ns, time_measurements_obj.tot_short_ns, time_measurements_obj.toa_ns ), UVM_LOW);
																																																																	end
																																																										end
																																																				end: no_error_other_test
																																					end: other_test
																													        // -------------------------------------------------------------------------
																													
																													    
																													end 
																								end
										          end
																				if (reporting_enable_obj.enable_reporting_dataoutcomparator_readoutacquired == `NO && all_data_equal_whole_column == `ROWS) begin
																							`uvm_info("compare", $sformatf(":) ALL_DATA_EQUAL in the whole column, chip_status: %s, column %0d", chip_status_obj.chip_status, dataout_transaction_actual.column_counter ), UVM_LOW);
																				end
									          	comparison_result_acquired.delete();
											
											end: status_readout_acquired
											
											
											else if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_FIRST_HALF || chip_status_obj.chip_status == STATUS_CONFIG_READOUT_SECOND_HALF) begin: status_config_readout
											         number_discrepancies_for_this_transaction = 0;
																				
											          
											         //comparison_result_configured = compare_two_columnconfig_broken_into_superpixelconfig ( .superpixel_config_measured(dataout_transaction_actual.column_config_breakdown), .superpixel_config_expected(dataout_transaction_ideal.column_config_breakdown) );
																				// In matrix model, where the expected configuration values are generated, for the second configuration half the first configuration half is already known and included in column_config_breakdown;
																				// however, in dataout monitor the first configuration half is unknown when the second configuration half is being built up into column_config_breakdown. Therefore, if we would compare the whole
																				// column_config_breakdown for the second configuration half, we would find a discrepancy in those values corresponding to the first configuration half. To avoid this, both portions of 
																				// column_config_breakdown are compared separately
																				if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_FIRST_HALF)
																				    comparison_result_configured = compare_two_columnconfig_broken_into_superpixelconfig_half ( .superpixel_config_measured(dataout_transaction_actual.column_config_breakdown), .superpixel_config_expected(dataout_transaction_ideal.column_config_breakdown),
																								                               .configuration_half(`FIRST_CONFIGURATION_HALF) );
																				else
																				    comparison_result_configured = compare_two_columnconfig_broken_into_superpixelconfig_half ( .superpixel_config_measured(dataout_transaction_actual.column_config_breakdown), .superpixel_config_expected(dataout_transaction_ideal.column_config_breakdown),
																								                               .configuration_half(`SECOND_CONFIGURATION_HALF) );
																																																	
																				for (int ss = 0; ss < `SUPERPIXEL_SEGMENTS; ss++) begin
																				     for (int sis = 0; sis < `SUPERPIXELS_IN_ONE_SEGMENT; sis++) begin																		
										                   aux_comparison_result_configured.delete(); aux_comparison_result_configured = comparison_result_configured[ss][sis];
																													
																													
																													
																		           foreach (aux_comparison_result_configured[j]) begin
																													    if (aux_comparison_result_configured[j] != ALL_CONFIG_EQUAL) begin
																																	
																																	
																																	                         if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_FIRST_HALF) begin

																																														         										`uvm_info("matrix config 1", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1[0] = %b MEASURED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1[0] = %b", 
                                                        										aux_comparison_result_configured[j], chip_status_obj.chip_status, dataout_transaction_ideal.column_counter, ss,sis,
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tpEnableDigital, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].mask,
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tpEnableAnalog, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC0,
																																																																	 dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[0],
																																																																		dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tpEnableDigital, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].mask,
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tpEnableAnalog, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC0,
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC1[0] ), UVM_LOW);
																																																										end
																																																										else begin

																																														         										`uvm_info("matrix config 2", $sformatf(":( %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: tuningDAC1[2] = %b,tuningDAC1[1] = %b, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h MEASURED: tuningDAC1[2] = %b, tuningDAC1[1] = %b, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h", 
                                                        										aux_comparison_result_configured[j], chip_status_obj.chip_status, dataout_transaction_ideal.column_counter, ss,sis,
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[2], dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1],
																																																																	 dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC2, 
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC3, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC4, 
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC5, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC6, 
																																																																		dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC7,
																																																																		dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC1[2], dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1],
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC2,
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC3, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC4,
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC5, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC6,
																																																																	 dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC7), UVM_LOW);
																																																										end
																																					
                                     increment_number_discrepancies();
																																					number_discrepancies_for_this_transaction++;
																																	end
																																	else begin
																																							      //`uvm_info("compare", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d", 
                                              //aux_comparison_result_configured[j], chip_status_obj.chip_status, dataout_transaction_actual.column_counter, ss,sis ), UVM_LOW);
																																														
                                              if (ss ==0 && sis ==0) begin
																																														                    if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_FIRST_HALF) begin

																																														         																				`uvm_info("matrix config 1", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1[0] = %b MEASURED: tpEnableDigital = %b, mask = %h, tpEnableAnalog = %h, tuningDAC0 = %h, tuningDAC1[0] = %b", 
                                                        																				aux_comparison_result_configured[j], chip_status_obj.chip_status, dataout_transaction_ideal.column_counter, ss,sis,
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tpEnableDigital, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].mask,
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tpEnableAnalog, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC0,
																																																																	 										dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[0],
																																																																												dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tpEnableDigital, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].mask,
																																																																	 										dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tpEnableAnalog, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC0,
																																																																	 										dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC1[0] ), UVM_LOW);
																																																																				end
																																																																				else begin

																																														         																				`uvm_info("matrix config 2", $sformatf(":) %s, chip_status: %s, column %0d, superpixel segment %0d, superpixel in segment %0d, EXPECTED: tuningDAC1[1:0] = %h, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h MEASURED: tuningDAC1[1:0] = %h, tuningDAC2 = %h, tuningDAC3 = %h, tuningDAC4 = %h, tuningDAC5 = %h, tuningDAC6 = %h, tuningDAC7 = %h", 
                                                        																				aux_comparison_result_configured[j], chip_status_obj.chip_status, dataout_transaction_ideal.column_counter, ss,sis,
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1:0], dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC2, 
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC3, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC4, 
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC5, dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC6, 
																																																																												dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC7,
																																																																												dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1:0], dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC2,
																																																																	 										dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC3, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC4,
																																																																	 										dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC5, dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC6,
																																																																	 										dataout_transaction_actual.column_config_breakdown.superpixel[ss][sis].tuningDAC7), UVM_LOW);
																																																																				end
																																													  end
																																	end
																													end 
																								end
										          end
																				//if (number_discrepancies_for_this_transaction == 0) begin
																				//    `uvm_info("compare", $sformatf(":) ALL_CONFIG_EQUAL, chip_status: %s, column %0d", chip_status_obj.chip_status, dataout_transaction_actual.column_counter), UVM_LOW);
																				//end
									          	comparison_result_configured.delete();

											
											end: status_config_readout
																	


           else begin: not_reset_status


						          aux_size_actual = dataout_transaction_actual.column_content.size();
						          aux_size_ideal = dataout_transaction_ideal.column_content.size();

                      if ( comparison_result ) begin 
                          `uvm_info("compare", $sformatf(":) DATA_OUT has the expected value for chip_status: %s, ideal = %h, actual = %h", chip_status_obj.chip_status,aux_vector_ideal, aux_vector_actual), UVM_LOW);
                      end
						                else if ( dataout_transaction_ideal.fields_with_error.exists(SIZE_COLUMNCONTENT) ) begin 
                          `uvm_info("compare", $sformatf(":( Different column content size for chip_status: %s, size ideal = %0d, size actual = %0d, ideal = %h, actual = %h", 
                                   chip_status_obj.chip_status, aux_size_ideal, aux_size_actual, aux_vector_ideal, aux_vector_actual), UVM_LOW);
                           increment_number_discrepancies();
                      end
                      else if ( dataout_transaction_ideal.fields_with_error.exists(COLUMN_COUNTER) ) begin
                           `uvm_info("compare", $sformatf(":( Different column counter for chip_status: %s, counter ideal = %0d, counter actual = %0d, ideal = %h, actual = %h", 
                                    chip_status_obj.chip_status, dataout_transaction_ideal.column_counter, dataout_transaction_actual.column_counter, aux_vector_ideal, aux_vector_actual), UVM_LOW);
                           increment_number_discrepancies();
                      end  
                      else if ( dataout_transaction_ideal.fields_with_error.exists(COLUMN_CONTENT) ) begin 
                           `uvm_info("compare", $sformatf(":( DATA_OUT does NOT have the expected value for chip_status: %s, size ideal = %0d, size actual = %0d, ideal = %h, actual = %h", 
                                    chip_status_obj.chip_status, aux_size_ideal, aux_size_actual, aux_vector_ideal, aux_vector_actual), UVM_LOW);
													 increment_number_discrepancies();
                      end       

					end: not_reset_status

          // Free the record of errors for the next comparison
          dataout_transaction_ideal.fields_with_error.delete();
		
	endfunction: compare
	


  //
  // Get a pair of transactions from the FIFOs and compare them
  task dataoutcomparator_action();
       CLICTD_dataout_transaction dataout_transaction_ideal, dataout_transaction_actual, aux_dataout_transaction_ideal, aux_dataout_transaction_actual;
       forever begin
							   aux_dataout_transaction_actual = CLICTD_dataout_transaction::type_id::create(.name("aux_dataout_transaction_actual"), .contxt(get_full_name()));
										aux_dataout_transaction_ideal = CLICTD_dataout_transaction::type_id::create(.name("aux_dataout_transaction_ideal"), .contxt(get_full_name()));
										actual_fifo.get(aux_dataout_transaction_actual);
										ideal_fifo.get(aux_dataout_transaction_ideal);
          assert($cast( dataout_transaction_ideal, aux_dataout_transaction_ideal.clone() ));
          assert($cast( dataout_transaction_actual, aux_dataout_transaction_actual.clone() ));
										
										
										
										/*
										if (chip_status_obj.chip_status == STATUS_CONFIG_READOUT_SECOND_HALF) begin
													    for (int ss = 0; ss < `SUPERPIXEL_SEGMENTS; ss++) begin
																	    for (int sis = 0; sis < `SUPERPIXELS_IN_ONE_SEGMENT; sis++) begin
																					    $display("DISPLAY - dataout comparator - EXPECTED: tuningDAC1[%0d][%0d][%0d][2] = %b, tuningDAC1[%0d][%0d][%0d][1] = %b, MEASURED: tuningDAC1[%0d][%0d][%0d][2] = %b, tuningDAC1[%0d][%0d][%0d][1] = %b",
																									         dataout_transaction_ideal.column_counter,ss,sis,dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[2],
																																		dataout_transaction_ideal.column_counter,ss,sis,dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1],
																																		dataout_transaction_actual.column_counter,ss,sis,dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[2],
																																		dataout_transaction_actual.column_counter,ss,sis,dataout_transaction_ideal.column_config_breakdown.superpixel[ss][sis].tuningDAC1[1]);
																					end
																	end
										end
										*/
										
										assert_isunknown_dataout_transaction ( .dataout_transaction(dataout_transaction_ideal), .chip_status_obj(chip_status_obj), .name_of_transaction("dataout_transaction_ideal"), .name_of_calling_component(this.get_full_name()));
										assert_isunknown_dataout_transaction ( .dataout_transaction(dataout_transaction_actual), .chip_status_obj(chip_status_obj), .name_of_transaction("dataout_transaction_actual"), .name_of_calling_component(this.get_full_name()));
										
										
										aux_vector_ideal = '0; aux_vector_actual = '0;										
          for(int i = 0; i < dataout_transaction_actual.column_content.num(); i++) begin
						  						aux_vector_actual[i] = dataout_transaction_actual.column_content[i];
          end
										for(int i = 0; i < dataout_transaction_ideal.column_content.num(); i++) begin
						  						aux_vector_ideal[i] = dataout_transaction_ideal.column_content[i];
          end
										if (chip_status_obj.chip_status != STATUS_RESET) begin
                   `uvm_info("Retrieved from FIFOs", $sformatf("Transaction from dataout_agent/dataout_model: column_counter = %0d/%0d, chip_status = %s, content ideal %0d bits = %h, content actual %0d bits = %h", 
										          dataout_transaction_actual.column_counter, dataout_transaction_ideal.column_counter, chip_status_obj.chip_status, dataout_transaction_ideal.column_content.num(), aux_vector_ideal, dataout_transaction_actual.column_content.num(), aux_vector_actual),  UVM_LOW)
										end
										else begin
										          `uvm_info("Retrieved from FIFOs", $sformatf("Transaction from dataout_agent/dataout_model: column_counter = %0d/%0d, chip_status = %s", 
										          dataout_transaction_actual.column_counter, dataout_transaction_ideal.column_counter, chip_status_obj.chip_status),  UVM_LOW)
										end
					     compare( dataout_transaction_ideal, dataout_transaction_actual );
				end
  endtask: dataoutcomparator_action
  //
  // Handle a timeout occured when waiting for the start readout condition
  task timeout_action();
       forever begin
				         events_obj.timeout_start_readout_event.wait_trigger();
				         events_obj.timeout_start_readout_event.reset();
				         `uvm_info("compare", $sformatf(":( Timeout condition for start readout, chip_status: %s", chip_status_obj.chip_status), UVM_LOW);
             			if ( !number_discrepancies.exists(chip_status_obj.chip_status) ) number_discrepancies[chip_status_obj.chip_status] = 1;
                  else increment_number_discrepancies();
       end
   endtask: timeout_action



endclass: CLICTD_dataout_comparator



`endif // __CLICTD_dataout_comparator_sv__

